// Copyright (C) 1992 James H. Price, All rights reserved
//
//  HINTTEST.CPP
//
//    Test program for HintStatusLine
//

#define Uses_MsgBox
#define Uses_TEvent
#define Uses_TApplication
#define Uses_TKeys
#define Uses_TRect
#define Uses_TMenu
#define Uses_TMenuBar
#define Uses_TMenuItem
#define Uses_TSubMenu
#define Uses_TStatusLine
#define Uses_TStatusItem
#define Uses_TStatusDef
#define Uses_TDeskTop
#include <tv.h>

#include "hint.h"
#include <stdlib.h>

const cmAbout = 100;
const cmFunc1 = 101;
const cmFunc2 = 102;
const cmFunc3 = 103;
const cmFunc4 = 104;

extern const char *hinthelp[] = {
  "This is hint One",
  "This is hint Two",
  "This is hint Three",
  "This is hint Four",
  "This is a hint for \"Test\"",
};

const hcFunc1 = 50;
const hcFunc2 = 51;
const hcFunc3 = 52;
const hcFunc4 = 53;
const hcTest  = 54;
extern const firstHint = 50;
extern const lastHint = 54;

class Shell : public TApplication {

public:

  Shell();
  static TMenuBar *initMenuBar( TRect r );
  static TStatusLine *initStatusLine( TRect r );
  void handleEvent( TEvent& event );

private:

  void About();
  void Test( ushort );
};

Shell::Shell() : TProgInit (
      &Shell::initStatusLine,
      &Shell::initMenuBar,
      &Shell::initDeskTop
      )
{
}

TMenuBar *Shell::initMenuBar( TRect r )
{
  r.b.y = r.a.y + 1;

  return new TMenuBar( r,
    *new TSubMenu( "~T~est", kbAltF, hcTest ) +
      *new TMenuItem( "Func ~O~ne", cmFunc1, kbNoKey, hcFunc1 ) +
      *new TMenuItem( "Func ~T~wo", cmFunc2, kbNoKey, hcFunc2 ) +
      *new TMenuItem( "Func T~h~ree", cmFunc3, kbNoKey, hcFunc3 ) +
      *new TMenuItem( "Func ~F~our", cmFunc4, kbNoKey, hcFunc4 ) );
}

TStatusLine *Shell::initStatusLine( TRect r )
{
  r.a.y = r.b.y - 1;

  return new HintStatusLine( r,
    *new TStatusDef(0, firstHint-1) +
      *new TStatusItem( "~F10~ Menu", kbF10, cmMenu ) +
      *new TStatusItem( "~Alt-X~ Quit", kbAltX, cmQuit ) +

    *new TStatusDef(firstHint, 0xFFFF) +
      *new TStatusItem( 0, kbF10, cmMenu ) +
      *new TStatusItem( "~F1~ Help", kbF1, cmHelp ) );
}

void Shell::handleEvent( TEvent &event )
{
  TApplication::handleEvent(event);

  if (event.what == evCommand)
  {
    switch (event.message.command)
    {
      case cmAbout:
        About();
        break;
      case cmFunc1:
      case cmFunc2:
      case cmFunc3:
      case cmFunc4:
        Test( event.message.command );
        break;
      default:
        break;
    }
  }
}

void Shell::About()
{
  messageBox( "\003HintStatusLine Demo",
    mfInformation | mfOKButton );
}

void Shell::Test( ushort cmd )
{
  char msg[30]= "\003Executing Function ";

  int which = cmd-cmFunc1+1;
  itoa( which, msg+20, 10 );
  messageBox( msg, mfInformation | mfOKButton );
}

int main()
{
  TEvent init;
  init.what = evCommand;
  init.message.command = cmAbout;     // make a cmAbout command event

  Shell shell;
  shell.putEvent(init);               // put it in the queue to pop up
  shell.run();                        // About box when program starts
  return 0;
}

